#pragma once

#include "field_value.h"

namespace cpphibernate {
namespace mariadb {

    /**
     * @brief Field that represents a data field.
     */
    template<typename T_field>
    struct field_data_t
        : public field_value_t<T_field>
    {
    private:
        using base_type = field_value_t<T_field>;

    public:
        /**
         * @brief Value constructor. Creates a mariadb field from the cpphibernate field.
         *
         * @param[in] p_owner   Owner of the field.
         * @param[in] p_schema  Cpphibernate schema the mariadb field belongs to.
         * @param[in] p_table   Cpphibernate table the mariadb field belongs to.
         * @param[in] p_field   Cpphibernate field to create mariadb field for.
         */
        template<
            typename T_schema,
            typename T_table>
        inline field_data_t(
            const table_t&  p_owner,
            const T_schema& p_schema,
            const T_table&  p_table,
            const T_field&  p_field);
    };

} }
