#pragma once



namespace cpphibernate {
namespace mariadb {

    /**
     * @brief Field that completely implementes the abstract field_t
     */
    template<typename T_field>
    struct field_simple_t
        : public field_t
    {
    private:
        using base_type = field_t;
        using field_type = T_field;

    protected:
        const field_type& _field;

    public:
        /**
         * @brief Value constructor. Creates a mariadb field from the cpphibernate field.
         *
         * @param[in] p_owner   Owner of the field.
         * @param[in] p_schema  Cpphibernate schema the mariadb field belongs to.
         * @param[in] p_table   Cpphibernate table the mariadb field belongs to.
         * @param[in] p_field   Cpphibernate field to create mariadb field for.
         */
        template<
            typename T_schema,
            typename T_table>
        inline field_simple_t(
            const table_t&  p_owner,
            const T_schema& p_schema,
            const T_table&  p_table,
            const T_field&  p_field);
    };

} }
