#pragma once

#include "table.h"

namespace cpphibernate {
namespace mariadb {

    /**
     * @brief Table for non polymorphic datatypes.
     */
    struct table_simple_t
        : public table_t
    {
    public:
        /**
         * @brief Value constructor. Creates a mariadb table from the cpphibernate table.
         *
         * @param[in] p_owner   Owner of the table.
         * @param[in] p_schema  Cpphibernate schema the table belongs to.
         * @param[in] p_table   Cpphibernate table to create mariadb table for.
         */
        template<
            typename T_schema,
            typename T_table,
            typename T_base_dataset,
            typename T_derived_datasets>
        inline table_simple_t(
            const schema_t& p_owner,
            const T_schema& p_schema,
            const T_table&  p_table,
            const T_base_dataset&&,
            const T_derived_datasets&&);
    };

} }
