#pragma once

namespace cpphibernate {
namespace mariadb {

    /**
     * @brief Vector of tables.
     */
    struct tables_t
        : public std::vector<table_ptr_u>
    {
        using base_type = std::vector<table_ptr_u>;
        using base_type::base_type;
    };

    namespace __impl
    {

        /**
         * @brief Helper class to create table vector.
         */
        template<typename X, typename = void>
        struct tables_builder;

    }

    /**
     * @brief Predicate to create table vector.
     */
    constexpr decltype(auto) make_tables = mp::generic_predicate<__impl::tables_builder> { };

} }
