#pragma once

#include <cppmariadb.h>

namespace cpphibernate {
namespace mariadb {

    struct schema_t;

    /**
     * @brief Base class for all mariadb driver context classes.
     */
    struct base_context
    {
        const schema_t&             schema;     //!< schema to use for the operation
        ::cppmariadb::connection&   connection; //!< mariadb connection to use for executing queries

        /**
         * @brief Constructor.
         */
        inline base_context(
            const schema_t&             p_schema,
            ::cppmariadb::connection&   p_connection);
    };

} }
