#pragma once

#include "data_context.h"

namespace cpphibernate {
namespace mariadb {

    /**
     * @brief Mariadb driver context for deleting datasets from the database.
     */
    struct destroy_context
        : public data_context
    {
        std::string where; //!< Where clause for deleting datasets.

        template<typename T_dataset>
        inline destroy_context(
            const schema_t&             p_schema,
            ::cppmariadb::connection&   p_connection,
            T_dataset&                  p_dataset);
    };

} }
