#pragma once

namespace cpphibernate {
namespace mariadb {

    /**
     * @brief Helper class to manage operations on nullable types.
     */
    template<typename T_container, typename = void>
    struct container_helper
    {
        using container_type = T_container;
        using value_type     = typename container_type::value_type;

        /**
         * @brief Emplace a new dataset in the container.
         */
        template<typename... X_args>
        static inline value_type& emplace(container_type& container, X_args&&... args) = delete;

        /**
         * @brief Clear the whole container.
         */
        static inline void clear(container_type& container) = delete;
    };

} }
