#pragma once

namespace cpphibernate {
namespace mariadb {

    /**
     * @brief Helper class to manage operations on nullable types.
     */
    template<typename T_nullable, typename = void>
    struct nullable_helper
    {
        using nullable_type = T_nullable;
        using value_type    = real_dataset_t<nullable_type>;

        /**
         * @brief Get a pointer to the stored value of the nullable object.
         */
        static value_type* get(const nullable_type&) = delete;

        /**
         * @brief Set the new value of the nullable object.
         */
        static value_type& set(nullable_type&, const value_type&) = delete;

        /**
         * @brief Destroy the stored value of a nullable objec (clear the nullable object).
         */
        static void clear(nullable_type&) = delete;
    };

} }
