#pragma once

#include <cpphibernate/config.h>

namespace cpphibernate
{

    namespace __impl
    {

        /**
         * @brief Helper class to build limit objects.
         */
        template<typename X, typename = void>
        struct limit_builder;

    }

    /**
     * @brief Evaluates to true_t if the passed type is a limit modifier, false_t otherwise.
     */
    template<typename T>
    struct is_limit_modifier;

    /**
     * @brief Is true if the passed type is a limit modifier, false otherwise.
     */
    template<typename T>
    constexpr decltype(auto) is_limit_modifier_v = is_limit_modifier<T>::value;

    /**
     * @brief Predicate to create new limit objects.
     */
    constexpr decltype(auto) limit = mp::generic_predicate<__impl::limit_builder> { };

}

#include "limit.inl"
