#pragma once

#include <cpphibernate/config.h>

namespace cpphibernate
{

    namespace __impl
    {

        /**
         * @brief Tag class all modifiers are derived from.
         */
        struct tag_modifier;

    }

    /**
     * @brief Evaluates to true_t if the passed type is a modifier, false_t otherwise.
     */
    template<typename T>
    struct is_modifier;

    /**
     * @brief Is true if the passed type is a modifier, false otherwise.
     */
    template<typename T>
    constexpr decltype(auto) is_modifier_v = is_modifier<T>::value;

}

#include "modifier.inl"
