#pragma once

#include <cpphibernate/config.h>

namespace cpphibernate
{

    namespace __impl
    {

        /**
         * @brief Helper type to build modifiers.
         */
        template<typename T, typename = void>
        struct modifiers_builder;

    }

    /**
     * @brief Evaluates to true_t if the passed type is a modifiers type.
     */
    template<typename T>
    struct is_modifiers;

    /**
     * @brief Is true if the passed type is an modifiers type, false otherwise.
     */
    template<typename T>
    constexpr bool is_modifiers_v = is_modifiers<T>::value;

    /**
     * @brief Predicate to create an modifiers object from the passed modifiers.
     */
    constexpr decltype(auto) make_modifiers = mp::generic_predicate<__impl::modifiers_builder> { };

}

#include "modifiers.inl"
