#pragma once

#include <cpphibernate/config.h>

namespace cpphibernate
{

    namespace __impl
    {

        /**
         * @brief Helper class to build offset objects.
         */
        template<typename X, typename = void>
        struct offset_builder;

    }

    /**
     * @brief Evaluates to true_t if the passed type is a offset modifier, false_t otherwise.
     */
    template<typename T>
    struct is_offset_modifier;

    /**
     * @brief Is true if the passed type is a offset modifier, false otherwise.
     */
    template<typename T>
    constexpr decltype(auto) is_offset_modifier_v = is_offset_modifier<T>::value;

    /**
     * @brief Predicate to create new offset objects.
     */
    constexpr decltype(auto) offset = mp::generic_predicate<__impl::offset_builder> { };

}

#include "offset.inl"
