#pragma once

#include <cpphibernate/config.h>

namespace cpphibernate
{

    namespace __impl
    {

        /**
         * @brief Helper class to build order_by objects.
         */
        template<typename X, typename = void>
        struct order_by_builder;

    }

    /**
     * @brief Evaluates to true_t if the passed type is a offset modifier, false_t otherwise.
     */
    template<typename T>
    struct is_order_by_modifier;

    /**
     * @brief Is true if the passed type is a offset modifier, false otherwise.
     */
    template<typename T>
    constexpr decltype(auto) is_order_by_modifier_v = is_order_by_modifier<T>::value;

    /**
     * @brief Predicate to create new offset objects.
     */
    constexpr decltype(auto) order_by = mp::generic_predicate<__impl::order_by_builder> { };

}

#include "order_by.inl"
