#pragma once

#include <cpphibernate/config.h>

namespace cpphibernate
{

    namespace __impl
    {

        /**
         * @brief Helper class to build ascending objects.
         */
        template<typename X, typename = void>
        struct ascending_builder;

    }

    /**
     * @brief Evaluates to true_t if the passed type is a ascending order, false_t otherwise.
     */
    template<typename T>
    struct is_ascending;

    /**
     * @brief Is true if the passed type is a ascending order, false otherwise.
     */
    template<typename T>
    constexpr decltype(auto) is_ascending_v = is_ascending<T>::value;

    /**
     * @brief Predicate to create new ascending order objects.
     */
    constexpr decltype(auto) ascending = mp::generic_predicate<__impl::ascending_builder> { };

}

#include "ascending.inl"
