#pragma once

#include <cpphibernate/schema/field.h>

#include "ascending.h"
#include "order_direction.h"

namespace cpphibernate
{

    namespace __impl
    {

        /* ascending_t */

        template<typename T_field>
        struct ascending_t
            : public order_direction_t<T_field>
            { };

        /* ascending_builder */

        template<typename X, typename>
        struct ascending_builder
        {
            template<typename... T_args>
            static constexpr decltype(auto) apply(T_args&&... args)
                { static_assert(sizeof...(args) == -1, "Invalid parameters for hibernate::ascending(...)!"); }
        };

        template<typename T_field>
        struct ascending_builder<
            mp::list<T_field>,
            mp::enable_if_t<schema::is_field_v<mp::decay_t<T_field>>>>
        {
            static constexpr decltype(auto) apply(T_field&&)
                { return ascending_t<T_field> { }; }
        };

    }

    /* is_ascending */

    template<typename T>
    struct is_ascending
        : public mp::is_specialization_of<T, __impl::ascending_t>
        { };

}
