#pragma once

#include <cpphibernate/config.h>

namespace cpphibernate
{

    namespace __impl
    {

        /**
         * @brief Helper class to build descending objects.
         */
        template<typename X, typename = void>
        struct descending_builder;

    }

    /**
     * @brief Evaluates to true_t if the passed type is a descending order, false_t otherwise.
     */
    template<typename T>
    struct is_descending;

    /**
     * @brief Is true if the passed type is a descending order, false otherwise.
     */
    template<typename T>
    constexpr decltype(auto) is_descending_v = is_descending<T>::value;

    /**
     * @brief Predicate to create new descending order objects.
     */
    constexpr decltype(auto) descending = mp::generic_predicate<__impl::descending_builder> { };

}

#include "descending.inl"
