#pragma once

#include "descending.h"
#include "order_direction.h"

namespace cpphibernate
{

    namespace __impl
    {

        /* descending_t */

        template<typename T_field>
        struct descending_t
            : public order_direction_t<T_field>
            { };

        /* descending_builder */

        template<typename X, typename>
        struct descending_builder
        {
            template<typename... T_args>
            static constexpr decltype(auto) apply(T_args&&... args)
                { static_assert(sizeof...(args) == -1, "Invalid parameters for hibernate::descending(...)!"); }
        };

        template<typename T_field>
        struct descending_builder<
            mp::list<T_field>,
            mp::enable_if_t<schema::is_field_v<mp::decay_t<T_field>>>>
        {
            static constexpr decltype(auto) apply(T_field&&)
                { return descending_t<T_field> { }; }
        };

    }

    /* is_descending */

    template<typename T>
    struct is_descending
        : public mp::is_specialization_of<T, __impl::descending_t>
        { };

}
