#pragma once

#include <cpphibernate/config.h>

namespace cpphibernate
{

    namespace __impl
    {

        /**
         * @brief Helper class to build where objects.
         */
        template<typename X, typename = void>
        struct where_builder;

    }

    /**
     * @brief Evaluates to true_t if the passed type is a where modifier, false_t otherwise.
     */
    template<typename T>
    struct is_where_modifier;

    /**
     * @brief Is true if the passed type is a where modifier, false otherwise.
     */
    template<typename T>
    constexpr decltype(auto) is_where_modifier_v = is_where_modifier<T>::value;

    /**
     * @brief Predicate to create new where objects.
     */
    constexpr decltype(auto) where = mp::generic_predicate<__impl::where_builder> { };

}

#include "where.inl"
