#pragma once

#include <cpphibernate/config.h>

namespace cpphibernate
{

    namespace __impl
    {

        /**
         * @brief Helper class to build equal objects.
         */
        template<typename X, typename = void>
        struct equal_builder;

    }

    /**
     * @brief Evaluates to true_t if the passed type is a equal order, false_t otherwise.
     */
    template<typename T>
    struct is_equal;

    /**
     * @brief Is true if the passed type is a equal order, false otherwise.
     */
    template<typename T>
    constexpr decltype(auto) is_equal_v = is_equal<T>::value;

    /**
     * @brief Predicate to create new equal order objects.
     */
    constexpr decltype(auto) equal = mp::generic_predicate<__impl::equal_builder> { };

}

#include "equal.inl"
