#pragma once

#include <cpphibernate/config.h>
#include <cpphibernate/schema/attribute.h>

namespace cpphibernate {
namespace schema {

    namespace __impl
    {

        /**
         * @brief Helper type to build attributes.
         */
        template<typename T, typename = void>
        struct attributes_builder;

    }

    /**
     * @brief Evaluates to true_t if the passed type is a attributes type.
     */
    template<typename T>
    struct is_attributes;

    /**
     * @brief Is true if the passed type is an attributes type, false otherwise.
     */
    template<typename T>
    constexpr bool is_attributes_v = is_attributes<T>::value;

    /**
     * @brief Predicate to create an attributes object from the passed attributes.
     */
    constexpr decltype(auto) make_attributes = mp::generic_predicate<__impl::attributes_builder> { };

} }

#include "attributes.inl"
