#pragma once

#include <cpphibernate/config.h>
#include <cpphibernate/schema/field.h>

namespace cpphibernate {
namespace schema {

    namespace __impl
    {

        /**
         * @brief Helper type to build fields.
         */
        template<typename T, typename = void>
        struct fields_builder;

    }

    /**
     * @brief Evaluates to true_t if the passed type is a fields type.
     */
    template<typename T>
    struct is_fields;

    /**
     * @brief Is true if the passed type is an fields type, false otherwise.
     */
    template<typename T>
    constexpr bool is_fields_v = is_fields<T>::value;

    /**
     * @brief Predicate to create an fields object from the passed fields.
     */
    constexpr decltype(auto) make_fields = mp::generic_predicate<__impl::fields_builder> { };

} }

#include "fields.inl"
